#include <iostream>

using namespace std;
class Base {

public:
  int f() {
    cout << "Base::f()\n";
    return 1;
  }
  int f(string) { return 1; }
  void g() {}
};



class Derived1 : public Base {

public:
  void g() {}
};



class Derived2 : public Base {

public:

  // Redefinition:
  int f() {
    cout << "Derived2::f()\n";
    return 2;
  }
};



class Derived3 : public Base {

public:

  // Change return type:
  void f()  { cout << "Derived3::f()\n"; }
};

class Derived4 : public Base {

public:

  // Change argument list:
  int f(int)  {
    cout << "Derived4::f()\n";
    return 4;
  }

};



int main() {

  string s("hello");
  Derived1 d1;
  int x = d1.f();
  d1.f(s);

  Derived2 d2;
  x = d2.f();

//   d2.f(s); // string version hidden

  Derived3 d3;
    d3.f();
//!  x = d3.f(); // return int version hidden

  Derived4 d4;

//!  x = d4.f(); // f() version hidden

  x = d4.f(1);

} ///:~
